// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package blaze_models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// ShopResponse shop response
//
// swagger:model ShopResponse
type ShopResponse struct {

	// company logo URL
	// Example: https://connect-files-public.s3.amazonaws.com/1d405589-9408-4f00-8b00-b30bfbc636d1.png
	CompanyLogoURL string `json:"companyLogoURL,omitempty"`

	// shop
	Shop *ShopResponseShop `json:"shop,omitempty"`

	// tolerance map
	ToleranceMap *ShopResponseToleranceMap `json:"toleranceMap,omitempty"`
}

// Validate validates this shop response
func (m *ShopResponse) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateShop(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateToleranceMap(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponse) validateShop(formats strfmt.Registry) error {
	if swag.IsZero(m.Shop) { // not required
		return nil
	}

	if m.Shop != nil {
		if err := m.Shop.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponse) validateToleranceMap(formats strfmt.Registry) error {
	if swag.IsZero(m.ToleranceMap) { // not required
		return nil
	}

	if m.ToleranceMap != nil {
		if err := m.ToleranceMap.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this shop response based on the context it is used
func (m *ShopResponse) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateShop(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateToleranceMap(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponse) contextValidateShop(ctx context.Context, formats strfmt.Registry) error {

	if m.Shop != nil {
		if err := m.Shop.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponse) contextValidateToleranceMap(ctx context.Context, formats strfmt.Registry) error {

	if m.ToleranceMap != nil {
		if err := m.ToleranceMap.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponse) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponse) UnmarshalBinary(b []byte) error {
	var res ShopResponse
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShop shop response shop
//
// swagger:model ShopResponseShop
type ShopResponseShop struct {

	// active
	// Example: true
	Active bool `json:"active,omitempty"`

	// address
	Address *ShopResponseShopAddress `json:"address,omitempty"`

	// age limit
	// Example: 21
	AgeLimit float64 `json:"ageLimit,omitempty"`

	// al excise on zero price
	// Example: true
	AlExciseOnZeroPrice bool `json:"alExciseOnZeroPrice,omitempty"`

	// allow anonymous orders
	// Example: false
	AllowAnonymousOrders bool `json:"allowAnonymousOrders,omitempty"`

	// app target
	// Example: Retail
	AppTarget string `json:"appTarget,omitempty"`

	// assets
	Assets []*ShopResponseShopAssetsItems0 `json:"assets"`

	// auto cash drawer
	// Example: false
	AutoCashDrawer bool `json:"autoCashDrawer,omitempty"`

	// bcc email address
	// Example: info@pineappleexpress.com
	BccEmailAddress string `json:"bccEmailAddress,omitempty"`

	// cart minimums
	CartMinimums *ShopResponseShopCartMinimums `json:"cartMinimums,omitempty"`

	// checkout type
	// Example: Direct
	CheckoutType string `json:"checkoutType,omitempty"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1553982501824
	Created int64 `json:"created,omitempty"`

	// credit fefund type
	// Example: NONE
	CreditFefundType string `json:"creditFefundType,omitempty"`

	// default country
	// Example: US
	DefaultCountry string `json:"defaultCountry,omitempty"`

	// default pin timeout
	// Example: 5
	DefaultPinTimeout float64 `json:"defaultPinTimeout,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// delivery fee
	// Example: 0
	DeliveryFee float64 `json:"deliveryFee,omitempty"`

	// delivery refund type
	// Example: NONE
	DeliveryRefundType string `json:"deliveryRefundType,omitempty"`

	// email adress
	// Example: support@pineappleexpress.com
	EmailAdress string `json:"emailAdress,omitempty"`

	// email message
	// Example: string
	EmailMessage string `json:"emailMessage,omitempty"`

	// enable age limit
	// Example: true
	EnableAgeLimit bool `json:"enableAgeLimit,omitempty"`

	// enable b c c receipt
	// Example: true
	EnableBCCReceipt bool `json:"enableBCCReceipt,omitempty"`

	// enable cannabis limit
	// Example: true
	EnableCannabisLimit bool `json:"enableCannabisLimit,omitempty"`

	// enable cash in out
	// Example: false
	EnableCashInOut bool `json:"enableCashInOut,omitempty"`

	// enable daily summary email
	// Example: false
	EnableDailySummaryEmail bool `json:"enableDailySummaryEmail,omitempty"`

	// enable delivery fee
	// Example: false
	EnableDeliveryFee bool `json:"enableDeliveryFee,omitempty"`

	// enable delivery signature
	// Example: true
	EnableDeliverySignature bool `json:"enableDeliverySignature,omitempty"`

	// enable excise tax
	// Example: true
	EnableExciseTax bool `json:"enableExciseTax,omitempty"`

	// enable g p s tracking
	// Example: true
	EnableGPSTracking bool `json:"enableGPSTracking,omitempty"`

	// enable harvest tax
	// Example: false
	EnableHarvestTax bool `json:"enableHarvestTax,omitempty"`

	// enable low inventory email
	// Example: true
	EnableLowInventoryEmail bool `json:"enableLowInventoryEmail,omitempty"`

	// enable medicinal age
	// Example: true
	EnableMedicinalAge bool `json:"enableMedicinalAge,omitempty"`

	// enable on fleet
	// Example: true
	EnableOnFleet bool `json:"enableOnFleet,omitempty"`

	// enable pin for cash drawer
	// Example: false
	EnablePinForCashDrawer bool `json:"enablePinForCashDrawer,omitempty"`

	// enable sale logout
	// Example: false
	EnableSaleLogout bool `json:"enableSaleLogout,omitempty"`

	// enable spring big
	// Example: false
	EnableSpringBig bool `json:"enableSpringBig,omitempty"`

	// enable tookan
	// Example: false
	EnableTookan bool `json:"enableTookan,omitempty"`

	// enable woo commerce
	// Example: false
	EnableWooCommerce bool `json:"enableWooCommerce,omitempty"`

	// enforce cash drawers
	// Example: true
	EnforceCashDrawers bool `json:"enforceCashDrawers,omitempty"`

	// excise tax type
	// Example: TOTAL_AMOUNT
	ExciseTaxType string `json:"exciseTaxType,omitempty"`

	// hub Id
	// Example: JPowoWy*p6zFD5D*y9t77DNJ
	HubID string `json:"hubId,omitempty"`

	// hub name
	// Example: Palm Springs
	HubName string `json:"hubName,omitempty"`

	// id
	// Example: 5c9fe425e0faca07db94b970
	ID string `json:"id,omitempty"`

	// invoice note
	// Example: string
	InvoiceNote string `json:"invoiceNote,omitempty"`

	// invoice term condition
	// Example: string
	InvoiceTermCondition string `json:"invoiceTermCondition,omitempty"`

	// latitude
	// Example: 0
	Latitude float64 `json:"latitude,omitempty"`

	// legal language
	// Example: WARNING: This product can expose you to marijuana smoke and myrcene, which are known to the State of California to cause cancer. For more information, go to www.P65Warnings.ca.gov.
	LegalLanguage string `json:"legalLanguage,omitempty"`

	// license
	// Example: C9-18-0000102-TEMP
	License string `json:"license,omitempty"`

	// logo
	Logo *ShopResponseShopLogo `json:"logo,omitempty"`

	// longitude
	// Example: 0
	Longitude float64 `json:"longitude,omitempty"`

	// marketing sources
	// Example: ["On Deck","Weed Maps","Google","Personal Referral","Billboard","Social Media","Print Media","Other"]
	MarketingSources []string `json:"marketingSources"`

	// medicinal age
	// Example: 18
	MedicinalAge float64 `json:"medicinalAge,omitempty"`

	// members count sync date
	// Example: 1558372668851
	MembersCountSyncDate float64 `json:"membersCountSyncDate,omitempty"`

	// members tag
	// Example: ["Disabled"]
	MembersTag []string `json:"membersTag"`

	// modified
	// Example: 1558372668851
	Modified int64 `json:"modified,omitempty"`

	// nal excise from retail cost
	// Example: false
	NalExciseFromRetailCost bool `json:"nalExciseFromRetailCost,omitempty"`

	// name
	// Example: Pineapple Express Palm Springs
	Name string `json:"name,omitempty"`

	// next snapshot time
	// Example: 1558422300000
	NextSnapshotTime int64 `json:"nextSnapshotTime,omitempty"`

	// num allow active trans
	// Example: 1
	NumAllowActiveTrans float64 `json:"numAllowActiveTrans,omitempty"`

	// on fleet Api key
	// Example: d3ba42b1b557f703910d53d1a45be8ed
	OnFleetAPIKey string `json:"onFleetApiKey,omitempty"`

	// on fleet organization Id
	// Example: ziXWVNJiLeB2IeMUN5kSdIkX
	OnFleetOrganizationID string `json:"onFleetOrganizationId,omitempty"`

	// on fleet organization name
	// Example: Pineapple Express
	OnFleetOrganizationName string `json:"onFleetOrganizationName,omitempty"`

	// online store info
	OnlineStoreInfo *ShopResponseShopOnlineStoreInfo `json:"onlineStoreInfo,omitempty"`

	// order tags
	// Example: ["Appointment","Early Bird","Late Gift"]
	OrderTags []string `json:"orderTags"`

	// phone number
	// Example: (877) 933-3548
	PhoneNumber string `json:"phoneNumber,omitempty"`

	// po note
	// Example: string
	PoNote string `json:"poNote,omitempty"`

	// po term condition
	// Example: string
	PoTermCondition string `json:"poTermCondition,omitempty"`

	// product price include excise tax
	// Example: false
	ProductPriceIncludeExciseTax bool `json:"productPriceIncludeExciseTax,omitempty"`

	// products tag
	// Example: ["Flower","Concentrate","Edibles","Vegan","vegan","Preroll","Vape Pens","Topical","Wraps"]
	ProductsTag []string `json:"productsTag"`

	// receipt info
	ReceiptInfo []*ShopResponseShopReceiptInfoItems0 `json:"receiptInfo"`

	// receiving inventory Id
	// Example: 5c9fe425e0faca07db94b990
	ReceivingInventoryID string `json:"receivingInventoryId,omitempty"`

	// require valid rec date
	// Example: true
	RequireValidRecDate bool `json:"requireValidRecDate,omitempty"`

	// restrict incoming order notifications
	// Example: true
	RestrictIncomingOrderNotifications bool `json:"restrictIncomingOrderNotifications,omitempty"`

	// restricted notification terminals
	// Example: ["5c82b36db4ab160827412e62","5c82b3944442190831bca731","5cb7d5f54cd84907f647b6cd"]
	RestrictedNotificationTerminals []string `json:"restrictedNotificationTerminals"`

	// restricted views
	// Example: true
	RestrictedViews bool `json:"restrictedViews,omitempty"`

	// round off type
	// Example: NONE
	RoundOffType string `json:"roundOffType,omitempty"`

	// round up message
	// Example: string
	RoundUpMessage string `json:"roundUpMessage,omitempty"`

	// shop type
	// Example: Both
	ShopType string `json:"shopType,omitempty"`

	// short identifier
	// Example: string
	ShortIdentifier string `json:"shortIdentifier,omitempty"`

	// show delivery queue
	// Example: true
	ShowDeliveryQueue bool `json:"showDeliveryQueue,omitempty"`

	// show online queue
	// Example: false
	ShowOnlineQueue bool `json:"showOnlineQueue,omitempty"`

	// show product by available quantity
	// Example: true
	ShowProductByAvailableQuantity bool `json:"showProductByAvailableQuantity,omitempty"`

	// show special queue
	// Example: false
	ShowSpecialQueue bool `json:"showSpecialQueue,omitempty"`

	// show walk in queue
	// Example: false
	ShowWalkInQueue bool `json:"showWalkInQueue,omitempty"`

	// snapshop time
	// Example: 1558336185744
	SnapshopTime int64 `json:"snapshopTime,omitempty"`

	// tax info
	TaxInfo *ShopResponseShopTaxInfo `json:"taxInfo,omitempty"`

	// tax order
	// Example: PostTaxed
	TaxOrder string `json:"taxOrder,omitempty"`

	// tax round off type
	// Example: ONE_CENT
	TaxRoundOffType string `json:"taxRoundOffType,omitempty"`

	// tax tables
	TaxTables []*ShopResponseShopTaxTablesItems0 `json:"taxTables"`

	// time zone
	// Example: America/Los_Angeles
	TimeZone string `json:"timeZone,omitempty"`

	// timezone offset in minutes
	// Example: -420
	TimezoneOffsetInMinutes float64 `json:"timezoneOffsetInMinutes,omitempty"`

	// twilio number
	// Example: string
	TwilioNumber string `json:"twilioNumber,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// use assigned employee
	// Example: false
	UseAssignedEmployee bool `json:"useAssignedEmployee,omitempty"`

	// use complex tax
	// Example: true
	UseComplexTax bool `json:"useComplexTax,omitempty"`
}

// Validate validates this shop response shop
func (m *ShopResponseShop) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAddress(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAssets(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCartMinimums(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLogo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOnlineStoreInfo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateReceiptInfo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTaxInfo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTaxTables(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseShop) validateAddress(formats strfmt.Registry) error {
	if swag.IsZero(m.Address) { // not required
		return nil
	}

	if m.Address != nil {
		if err := m.Address.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "address")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) validateAssets(formats strfmt.Registry) error {
	if swag.IsZero(m.Assets) { // not required
		return nil
	}

	for i := 0; i < len(m.Assets); i++ {
		if swag.IsZero(m.Assets[i]) { // not required
			continue
		}

		if m.Assets[i] != nil {
			if err := m.Assets[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "assets" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ShopResponseShop) validateCartMinimums(formats strfmt.Registry) error {
	if swag.IsZero(m.CartMinimums) { // not required
		return nil
	}

	if m.CartMinimums != nil {
		if err := m.CartMinimums.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "cartMinimums")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) validateLogo(formats strfmt.Registry) error {
	if swag.IsZero(m.Logo) { // not required
		return nil
	}

	if m.Logo != nil {
		if err := m.Logo.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "logo")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) validateOnlineStoreInfo(formats strfmt.Registry) error {
	if swag.IsZero(m.OnlineStoreInfo) { // not required
		return nil
	}

	if m.OnlineStoreInfo != nil {
		if err := m.OnlineStoreInfo.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "onlineStoreInfo")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) validateReceiptInfo(formats strfmt.Registry) error {
	if swag.IsZero(m.ReceiptInfo) { // not required
		return nil
	}

	for i := 0; i < len(m.ReceiptInfo); i++ {
		if swag.IsZero(m.ReceiptInfo[i]) { // not required
			continue
		}

		if m.ReceiptInfo[i] != nil {
			if err := m.ReceiptInfo[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "receiptInfo" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ShopResponseShop) validateTaxInfo(formats strfmt.Registry) error {
	if swag.IsZero(m.TaxInfo) { // not required
		return nil
	}

	if m.TaxInfo != nil {
		if err := m.TaxInfo.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "taxInfo")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) validateTaxTables(formats strfmt.Registry) error {
	if swag.IsZero(m.TaxTables) { // not required
		return nil
	}

	for i := 0; i < len(m.TaxTables); i++ {
		if swag.IsZero(m.TaxTables[i]) { // not required
			continue
		}

		if m.TaxTables[i] != nil {
			if err := m.TaxTables[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "taxTables" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this shop response shop based on the context it is used
func (m *ShopResponseShop) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAddress(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateAssets(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCartMinimums(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLogo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOnlineStoreInfo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateReceiptInfo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTaxInfo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTaxTables(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseShop) contextValidateAddress(ctx context.Context, formats strfmt.Registry) error {

	if m.Address != nil {
		if err := m.Address.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "address")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) contextValidateAssets(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Assets); i++ {

		if m.Assets[i] != nil {
			if err := m.Assets[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "assets" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ShopResponseShop) contextValidateCartMinimums(ctx context.Context, formats strfmt.Registry) error {

	if m.CartMinimums != nil {
		if err := m.CartMinimums.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "cartMinimums")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) contextValidateLogo(ctx context.Context, formats strfmt.Registry) error {

	if m.Logo != nil {
		if err := m.Logo.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "logo")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) contextValidateOnlineStoreInfo(ctx context.Context, formats strfmt.Registry) error {

	if m.OnlineStoreInfo != nil {
		if err := m.OnlineStoreInfo.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "onlineStoreInfo")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) contextValidateReceiptInfo(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ReceiptInfo); i++ {

		if m.ReceiptInfo[i] != nil {
			if err := m.ReceiptInfo[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "receiptInfo" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ShopResponseShop) contextValidateTaxInfo(ctx context.Context, formats strfmt.Registry) error {

	if m.TaxInfo != nil {
		if err := m.TaxInfo.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("shop" + "." + "taxInfo")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShop) contextValidateTaxTables(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.TaxTables); i++ {

		if m.TaxTables[i] != nil {
			if err := m.TaxTables[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "taxTables" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShop) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShop) UnmarshalBinary(b []byte) error {
	var res ShopResponseShop
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopAddress shop response shop address
//
// swagger:model ShopResponseShopAddress
type ShopResponseShopAddress struct {

	// address
	// Example: 695 Williams Rd
	Address string `json:"address,omitempty"`

	// address line1
	AddressLine1 string `json:"addressLine1,omitempty"`

	// city
	// Example: Palm Springs
	City string `json:"city,omitempty"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// country
	// Example: US
	Country string `json:"country,omitempty"`

	// created
	// Example: 1553982501824
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// id
	// Example: 5c9fe425e0faca07db94b971
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1553982501824
	Modified int64 `json:"modified,omitempty"`

	// state
	// Example: CA
	State string `json:"state,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// zip code
	// Example: 92264
	ZipCode string `json:"zipCode,omitempty"`
}

// Validate validates this shop response shop address
func (m *ShopResponseShopAddress) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop address based on context it is used
func (m *ShopResponseShopAddress) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopAddress) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopAddress) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopAddress
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopAssetsItems0 shop response shop assets items0
//
// swagger:model ShopResponseShopAssetsItems0
type ShopResponseShopAssetsItems0 struct {

	// active
	// Example: true
	Active bool `json:"active,omitempty"`

	// asset type
	// Example: Document
	AssetType string `json:"assetType,omitempty"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1558145178150
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// id
	// Example: 5cdf689a59ded8080e03c06a
	ID string `json:"id,omitempty"`

	// key
	// Example: f5777926-e5cd-48c3-a026-a527bfaa930f.pdf
	Key string `json:"key,omitempty"`

	// large URL
	// Example: string
	LargeURL string `json:"largeURL,omitempty"`

	// large x2 URL
	// Example: string
	LargeX2URL string `json:"largeX2URL,omitempty"`

	// medium URL
	// Example: string
	MediumURL string `json:"mediumURL,omitempty"`

	// modified
	// Example: 1558145178150
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: CGI Sellers Permit 247130880 - 00001.pdf
	Name string `json:"name,omitempty"`

	// orig URL
	// Example: string
	OrigURL string `json:"origURL,omitempty"`

	// priority
	// Example: 0
	Priority float64 `json:"priority,omitempty"`

	// public URL
	// Example: string
	PublicURL string `json:"publicURL,omitempty"`

	// secured
	// Example: true
	Secured bool `json:"secured,omitempty"`

	// thumb URL
	// Example: string
	ThumbURL string `json:"thumbURL,omitempty"`

	// type
	// Example: Document
	Type string `json:"type,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop assets items0
func (m *ShopResponseShopAssetsItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop assets items0 based on context it is used
func (m *ShopResponseShopAssetsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopAssetsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopAssetsItems0) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopAssetsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopCartMinimums shop response shop cart minimums
//
// swagger:model ShopResponseShopCartMinimums
type ShopResponseShopCartMinimums struct {

	// cart minimum details
	CartMinimumDetails []*ShopResponseShopCartMinimumsCartMinimumDetailsItems0 `json:"cartMinimumDetails"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1553984069346
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// id
	// Example: 5c9fea45b8bccf07fc47d5cc
	ID string `json:"id,omitempty"`

	// minimums type
	// Example: SIMPLE
	MinimumsType string `json:"minimumsType,omitempty"`

	// modified
	// Example: 1553984069346
	Modified int64 `json:"modified,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop cart minimums
func (m *ShopResponseShopCartMinimums) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCartMinimumDetails(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseShopCartMinimums) validateCartMinimumDetails(formats strfmt.Registry) error {
	if swag.IsZero(m.CartMinimumDetails) { // not required
		return nil
	}

	for i := 0; i < len(m.CartMinimumDetails); i++ {
		if swag.IsZero(m.CartMinimumDetails[i]) { // not required
			continue
		}

		if m.CartMinimumDetails[i] != nil {
			if err := m.CartMinimumDetails[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "cartMinimums" + "." + "cartMinimumDetails" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this shop response shop cart minimums based on the context it is used
func (m *ShopResponseShopCartMinimums) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCartMinimumDetails(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseShopCartMinimums) contextValidateCartMinimumDetails(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.CartMinimumDetails); i++ {

		if m.CartMinimumDetails[i] != nil {
			if err := m.CartMinimumDetails[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("shop" + "." + "cartMinimums" + "." + "cartMinimumDetails" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopCartMinimums) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopCartMinimums) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopCartMinimums
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopCartMinimumsCartMinimumDetailsItems0 shop response shop cart minimums cart minimum details items0
//
// swagger:model ShopResponseShopCartMinimumsCartMinimumDetailsItems0
type ShopResponseShopCartMinimumsCartMinimumDetailsItems0 struct {

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// minimum
	// Example: 40
	Minimum float64 `json:"minimum,omitempty"`
}

// Validate validates this shop response shop cart minimums cart minimum details items0
func (m *ShopResponseShopCartMinimumsCartMinimumDetailsItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop cart minimums cart minimum details items0 based on context it is used
func (m *ShopResponseShopCartMinimumsCartMinimumDetailsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopCartMinimumsCartMinimumDetailsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopCartMinimumsCartMinimumDetailsItems0) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopCartMinimumsCartMinimumDetailsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopLogo shop response shop logo
//
// swagger:model ShopResponseShopLogo
type ShopResponseShopLogo struct {

	// active
	// Example: true
	Active bool `json:"active,omitempty"`

	// asset type
	// Example: Photo
	AssetType string `json:"assetType,omitempty"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1555870891770
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// id
	// Example: 5cbcb4ab85c8ac07ed72aac0
	ID string `json:"id,omitempty"`

	// key
	// Example: 5d145b98-e563-40ec-bf50-189fa275888d.jpg
	Key string `json:"key,omitempty"`

	// large URL
	// Example: https://connect-files-public.s3.amazonaws.com/5d145b98-e563-40ec-bf50-189fa275888d-800x800.jpg
	LargeURL string `json:"largeURL,omitempty"`

	// large x2 URL
	// Example: https://connect-files-p1.s3.amazonaws.com/5d145b98-e563-40ec-bf50-189fa275888d-1600x1600.jpg
	LargeX2URL string `json:"largeX2URL,omitempty"`

	// medium URL
	// Example: https://connect-files-public.s3.amazonaws.com/5d145b98-e563-40ec-bf50-189fa275888d-500x500.jpg
	MediumURL string `json:"mediumURL,omitempty"`

	// modified
	// Example: 1555870891770
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: PE New.jpg
	Name string `json:"name,omitempty"`

	// orig URL
	// Example: https://connect-files-public.s3.amazonaws.com/5d145b98-e563-40ec-bf50-189fa275888d.jpg
	OrigURL string `json:"origURL,omitempty"`

	// priority
	// Example: 0
	Priority float64 `json:"priority,omitempty"`

	// public URL
	// Example: https://connect-files-public.s3.amazonaws.com/5d145b98-e563-40ec-bf50-189fa275888d.jpg
	PublicURL string `json:"publicURL,omitempty"`

	// secured
	// Example: false
	Secured bool `json:"secured,omitempty"`

	// thumb URL
	// Example: https://connect-files-public.s3.amazonaws.com/5d145b98-e563-40ec-bf50-189fa275888d-200x200.jpg
	ThumbURL string `json:"thumbURL,omitempty"`

	// type
	// Example: Photo
	Type string `json:"type,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop logo
func (m *ShopResponseShopLogo) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop logo based on context it is used
func (m *ShopResponseShopLogo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopLogo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopLogo) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopLogo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopOnlineStoreInfo shop response shop online store info
//
// swagger:model ShopResponseShopOnlineStoreInfo
type ShopResponseShopOnlineStoreInfo struct {

	// active inventory Id
	// Example: string
	ActiveInventoryID string `json:"activeInventoryId,omitempty"`

	// cart min type
	// Example: SubtotalWithDiscount
	CartMinType string `json:"cartMinType,omitempty"`

	// cart minimum
	// Example: 0
	CartMinimum float64 `json:"cartMinimum,omitempty"`

	// color theme
	// Example: Light
	ColorTheme string `json:"colorTheme,omitempty"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1553984069346
	Created int64 `json:"created,omitempty"`

	// custom message e t a
	// Example: string
	CustomMessageETA string `json:"customMessageETA,omitempty"`

	// default e t a
	// Example: 90
	DefaultETA float64 `json:"defaultETA,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// enable delivery
	// Example: true
	EnableDelivery bool `json:"enableDelivery,omitempty"`

	// enable delivery area restrictions
	// Example: true
	EnableDeliveryAreaRestrictions bool `json:"enableDeliveryAreaRestrictions,omitempty"`

	// enable Html text
	// Example: false
	EnableHTMLText bool `json:"enableHtmlText,omitempty"`

	// enable inventory
	// Example: false
	EnableInventory bool `json:"enableInventory,omitempty"`

	// enable inventory type
	// Example: Custom
	EnableInventoryType string `json:"enableInventoryType,omitempty"`

	// enable online p o s
	// Example: true
	EnableOnlinePOS bool `json:"enableOnlinePOS,omitempty"`

	// enable online shipment
	// Example: false
	EnableOnlineShipment bool `json:"enableOnlineShipment,omitempty"`

	// enable other marketing source
	// Example: false
	EnableOtherMarketingSource bool `json:"enableOtherMarketingSource,omitempty"`

	// enable product reviews
	// Example: true
	EnableProductReviews bool `json:"enableProductReviews,omitempty"`

	// enable store pickup
	// Example: false
	EnableStorePickup bool `json:"enableStorePickup,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// html text
	// Example: string
	HTMLText string `json:"htmlText,omitempty"`

	// id
	// Example: 5c9fea45b8bccf07fc47d5cd
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1553984069346
	Modified int64 `json:"modified,omitempty"`

	// page one message body
	// Example: string
	PageOneMessageBody string `json:"pageOneMessageBody,omitempty"`

	// page one message title
	// Example: string
	PageOneMessageTitle string `json:"pageOneMessageTitle,omitempty"`

	// restricted zip codes
	// Example: ["90895","91001","91006","91007","93063"]
	RestrictedZipCodes []string `json:"restrictedZipCodes"`

	// shop Id
	// Example: 5c9fe425e0faca07db94b970
	ShopID string `json:"shopId,omitempty"`

	// store hex color
	// Example: string
	StoreHexColor string `json:"storeHexColor,omitempty"`

	// submission message
	// Example: string
	SubmissionMessage string `json:"submissionMessage,omitempty"`

	// support email
	// Example: support@pineappleexpress.com
	SupportEmail string `json:"supportEmail,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// use custom e t a
	// Example: false
	UseCustomETA bool `json:"useCustomETA,omitempty"`

	// view type
	// Example: List
	ViewType string `json:"viewType,omitempty"`

	// website origins
	WebsiteOrigins string `json:"websiteOrigins,omitempty"`

	// website Url
	// Example: https://pineappleexpress.com
	WebsiteURL string `json:"websiteUrl,omitempty"`
}

// Validate validates this shop response shop online store info
func (m *ShopResponseShopOnlineStoreInfo) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop online store info based on context it is used
func (m *ShopResponseShopOnlineStoreInfo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopOnlineStoreInfo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopOnlineStoreInfo) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopOnlineStoreInfo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopReceiptInfoItems0 shop response shop receipt info items0
//
// swagger:model ShopResponseShopReceiptInfoItems0
type ShopResponseShopReceiptInfoItems0 struct {

	// above free text
	// Example: TOP OF RECEIPT TEXT GOES HERE.
	AboveFreeText string `json:"aboveFreeText,omitempty"`

	// company Id
	// Example: string
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1557103750658
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// enable brand
	// Example: false
	EnableBrand bool `json:"enableBrand,omitempty"`

	// enable employee name
	// Example: true
	EnableEmployeeName bool `json:"enableEmployeeName,omitempty"`

	// enable excise tax as item
	// Example: true
	EnableExciseTaxAsItem bool `json:"enableExciseTaxAsItem,omitempty"`

	// enable include item in s k u
	// Example: false
	EnableIncludeItemInSKU bool `json:"enableIncludeItemInSKU,omitempty"`

	// enable member address
	// Example: false
	EnableMemberAddress bool `json:"enableMemberAddress,omitempty"`

	// enable member Id
	// Example: false
	EnableMemberID bool `json:"enableMemberId,omitempty"`

	// enable member loyalty points
	// Example: true
	EnableMemberLoyaltyPoints bool `json:"enableMemberLoyaltyPoints,omitempty"`

	// enable member name
	// Example: true
	EnableMemberName bool `json:"enableMemberName,omitempty"`

	// enable notes
	// Example: false
	EnableNotes bool `json:"enableNotes,omitempty"`

	// enable shop address
	// Example: false
	EnableShopAddress bool `json:"enableShopAddress,omitempty"`

	// enable shop phone no
	// Example: true
	EnableShopPhoneNo bool `json:"enableShopPhoneNo,omitempty"`

	// enabled bottom free text
	// Example: false
	EnabledBottomFreeText bool `json:"enabledBottomFreeText,omitempty"`

	// enabled free text
	// Example: false
	EnabledFreeText bool `json:"enabledFreeText,omitempty"`

	// free text
	// Example: BOTTOM OF RECEIPT TEXT GOES HERE.
	FreeText string `json:"freeText,omitempty"`

	// id
	// Example: string
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1557103750658
	Modified int64 `json:"modified,omitempty"`

	// receipt type
	// Example: SALES
	ReceiptType string `json:"receiptType,omitempty"`

	// shop Id
	// Example: string
	ShopID string `json:"shopId,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop receipt info items0
func (m *ShopResponseShopReceiptInfoItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop receipt info items0 based on context it is used
func (m *ShopResponseShopReceiptInfoItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopReceiptInfoItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopReceiptInfoItems0) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopReceiptInfoItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopTaxInfo shop response shop tax info
//
// swagger:model ShopResponseShopTaxInfo
type ShopResponseShopTaxInfo struct {

	// city tax
	// Example: 0
	CityTax float64 `json:"cityTax,omitempty"`

	// created
	// Example: 1553984069346
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// federal tax
	// Example: 0
	FederalTax float64 `json:"federalTax,omitempty"`

	// id
	// Example: 5c9fea45b8bccf07fc47d5ce
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1553984069346
	Modified int64 `json:"modified,omitempty"`

	// state tax
	// Example: 0.08
	StateTax float64 `json:"stateTax,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop tax info
func (m *ShopResponseShopTaxInfo) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop tax info based on context it is used
func (m *ShopResponseShopTaxInfo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopTaxInfo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopTaxInfo) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopTaxInfo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopTaxTablesItems0 shop response shop tax tables items0
//
// swagger:model ShopResponseShopTaxTablesItems0
type ShopResponseShopTaxTablesItems0 struct {

	// active
	// Example: false
	Active bool `json:"active,omitempty"`

	// city tax
	CityTax *ShopResponseShopTaxTablesItems0CityTax `json:"cityTax,omitempty"`

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// consumer type
	// Example: AdultUse
	ConsumerType string `json:"consumerType,omitempty"`

	// county tax
	CountyTax *ShopResponseShopTaxTablesItems0CountyTax `json:"countyTax,omitempty"`

	// created
	// Example: 1553984069346
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// federal tax
	FederalTax *ShopResponseShopTaxTablesItems0FederalTax `json:"federalTax,omitempty"`

	// id
	// Example: 5c9fea45b8bccf07fc47d5c9
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1553984069346
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: Adult Use
	Name string `json:"name,omitempty"`

	// shop Id
	// Example: 5c9fe425e0faca07db94b970
	ShopID string `json:"shopId,omitempty"`

	// state tax
	StateTax *ShopResponseShopTaxTablesItems0StateTax `json:"stateTax,omitempty"`

	// tax order
	// Example: PostTaxed
	TaxOrder string `json:"taxOrder,omitempty"`

	// tax type
	// Example: Inherit
	TaxType string `json:"taxType,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop tax tables items0
func (m *ShopResponseShopTaxTablesItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCityTax(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCountyTax(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFederalTax(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStateTax(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseShopTaxTablesItems0) validateCityTax(formats strfmt.Registry) error {
	if swag.IsZero(m.CityTax) { // not required
		return nil
	}

	if m.CityTax != nil {
		if err := m.CityTax.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cityTax")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShopTaxTablesItems0) validateCountyTax(formats strfmt.Registry) error {
	if swag.IsZero(m.CountyTax) { // not required
		return nil
	}

	if m.CountyTax != nil {
		if err := m.CountyTax.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("countyTax")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShopTaxTablesItems0) validateFederalTax(formats strfmt.Registry) error {
	if swag.IsZero(m.FederalTax) { // not required
		return nil
	}

	if m.FederalTax != nil {
		if err := m.FederalTax.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("federalTax")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShopTaxTablesItems0) validateStateTax(formats strfmt.Registry) error {
	if swag.IsZero(m.StateTax) { // not required
		return nil
	}

	if m.StateTax != nil {
		if err := m.StateTax.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("stateTax")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this shop response shop tax tables items0 based on the context it is used
func (m *ShopResponseShopTaxTablesItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCityTax(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCountyTax(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateFederalTax(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateStateTax(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseShopTaxTablesItems0) contextValidateCityTax(ctx context.Context, formats strfmt.Registry) error {

	if m.CityTax != nil {
		if err := m.CityTax.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cityTax")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShopTaxTablesItems0) contextValidateCountyTax(ctx context.Context, formats strfmt.Registry) error {

	if m.CountyTax != nil {
		if err := m.CountyTax.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("countyTax")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShopTaxTablesItems0) contextValidateFederalTax(ctx context.Context, formats strfmt.Registry) error {

	if m.FederalTax != nil {
		if err := m.FederalTax.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("federalTax")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseShopTaxTablesItems0) contextValidateStateTax(ctx context.Context, formats strfmt.Registry) error {

	if m.StateTax != nil {
		if err := m.StateTax.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("stateTax")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopTaxTablesItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopTaxTablesItems0CityTax shop response shop tax tables items0 city tax
//
// swagger:model ShopResponseShopTaxTablesItems0CityTax
type ShopResponseShopTaxTablesItems0CityTax struct {

	// active
	// Example: false
	Active bool `json:"active,omitempty"`

	// active excise tax
	// Example: false
	ActiveExciseTax bool `json:"activeExciseTax,omitempty"`

	// company Id
	// Example: string
	CompanyID string `json:"companyId,omitempty"`

	// compound
	// Example: false
	Compound bool `json:"compound,omitempty"`

	// created
	// Example: 1555534297286
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// id
	// Example: 5cb791d92f7a85083f3638ad
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1555534297286
	Modified int64 `json:"modified,omitempty"`

	// shop Id
	// Example: string
	ShopID string `json:"shopId,omitempty"`

	// tax order
	// Example: PostTaxed
	TaxOrder string `json:"taxOrder,omitempty"`

	// tax rate
	// Example: 0
	TaxRate float64 `json:"taxRate,omitempty"`

	// territory
	// Example: City
	Territory string `json:"territory,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop tax tables items0 city tax
func (m *ShopResponseShopTaxTablesItems0CityTax) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop tax tables items0 city tax based on context it is used
func (m *ShopResponseShopTaxTablesItems0CityTax) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0CityTax) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0CityTax) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopTaxTablesItems0CityTax
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopTaxTablesItems0CountyTax shop response shop tax tables items0 county tax
//
// swagger:model ShopResponseShopTaxTablesItems0CountyTax
type ShopResponseShopTaxTablesItems0CountyTax struct {

	// active
	// Example: true
	Active bool `json:"active,omitempty"`

	// active excise tax
	// Example: true
	ActiveExciseTax bool `json:"activeExciseTax,omitempty"`

	// company Id
	// Example: string
	CompanyID string `json:"companyId,omitempty"`

	// compound
	// Example: true
	Compound bool `json:"compound,omitempty"`

	// created
	// Example: 1555534297286
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// id
	// Example: 5cb791d92f7a85083f3638ae
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1555534297286
	Modified int64 `json:"modified,omitempty"`

	// shop Id
	// Example: string
	ShopID string `json:"shopId,omitempty"`

	// tax order
	// Example: PostTaxed
	TaxOrder string `json:"taxOrder,omitempty"`

	// tax rate
	// Example: 0.25
	TaxRate float64 `json:"taxRate,omitempty"`

	// territory
	// Example: County
	Territory string `json:"territory,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop tax tables items0 county tax
func (m *ShopResponseShopTaxTablesItems0CountyTax) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop tax tables items0 county tax based on context it is used
func (m *ShopResponseShopTaxTablesItems0CountyTax) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0CountyTax) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0CountyTax) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopTaxTablesItems0CountyTax
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopTaxTablesItems0FederalTax shop response shop tax tables items0 federal tax
//
// swagger:model ShopResponseShopTaxTablesItems0FederalTax
type ShopResponseShopTaxTablesItems0FederalTax struct {

	// active
	// Example: false
	Active bool `json:"active,omitempty"`

	// active excise tax
	// Example: false
	ActiveExciseTax bool `json:"activeExciseTax,omitempty"`

	// company Id
	// Example: string
	CompanyID string `json:"companyId,omitempty"`

	// compound
	// Example: false
	Compound bool `json:"compound,omitempty"`

	// created
	// Example: 1555534297286
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// id
	// Example: 5cb791d92f7a85083f3638b0
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1555534297286
	Modified int64 `json:"modified,omitempty"`

	// shop Id
	// Example: string
	ShopID string `json:"shopId,omitempty"`

	// tax order
	// Example: PostTaxed
	TaxOrder string `json:"taxOrder,omitempty"`

	// tax rate
	// Example: 0
	TaxRate float64 `json:"taxRate,omitempty"`

	// territory
	// Example: Federal
	Territory string `json:"territory,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop tax tables items0 federal tax
func (m *ShopResponseShopTaxTablesItems0FederalTax) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop tax tables items0 federal tax based on context it is used
func (m *ShopResponseShopTaxTablesItems0FederalTax) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0FederalTax) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0FederalTax) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopTaxTablesItems0FederalTax
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseShopTaxTablesItems0StateTax shop response shop tax tables items0 state tax
//
// swagger:model ShopResponseShopTaxTablesItems0StateTax
type ShopResponseShopTaxTablesItems0StateTax struct {

	// active
	// Example: true
	Active bool `json:"active,omitempty"`

	// active excise tax
	// Example: true
	ActiveExciseTax bool `json:"activeExciseTax,omitempty"`

	// company Id
	// Example: string
	CompanyID string `json:"companyId,omitempty"`

	// compound
	// Example: true
	Compound bool `json:"compound,omitempty"`

	// created
	// Example: 1555534297286
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// dirty
	// Example: false
	Dirty bool `json:"dirty,omitempty"`

	// id
	// Example: 5cb791d92f7a85083f3638af
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1555534297286
	Modified int64 `json:"modified,omitempty"`

	// shop Id
	// Example: string
	ShopID string `json:"shopId,omitempty"`

	// tax order
	// Example: PostTaxed
	TaxOrder string `json:"taxOrder,omitempty"`

	// tax rate
	// Example: 9.25
	TaxRate float64 `json:"taxRate,omitempty"`

	// territory
	// Example: State
	Territory string `json:"territory,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`
}

// Validate validates this shop response shop tax tables items0 state tax
func (m *ShopResponseShopTaxTablesItems0StateTax) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response shop tax tables items0 state tax based on context it is used
func (m *ShopResponseShopTaxTablesItems0StateTax) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0StateTax) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseShopTaxTablesItems0StateTax) UnmarshalBinary(b []byte) error {
	var res ShopResponseShopTaxTablesItems0StateTax
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMap shop response tolerance map
//
// swagger:model ShopResponseToleranceMap
type ShopResponseToleranceMap struct {

	// g RAM
	GRAM *ShopResponseToleranceMapGRAM `json:"GRAM,omitempty"`

	// h a l f
	HALF *ShopResponseToleranceMapHALF `json:"HALF,omitempty"`

	// h a l f g RAM
	HALFGRAM *ShopResponseToleranceMapHALFGRAM `json:"HALF_GRAM,omitempty"`

	// o n e e i g h t t h
	ONEEIGHTTH *ShopResponseToleranceMapONEEIGHTTH `json:"ONE_EIGHTTH,omitempty"`

	// o u n c e
	OUNCE *ShopResponseToleranceMapOUNCE `json:"OUNCE,omitempty"`

	// q u a r t e r
	QUARTER *ShopResponseToleranceMapQUARTER `json:"QUARTER,omitempty"`

	// t h r e e g RAM s
	THREEGRAMS *ShopResponseToleranceMapTHREEGRAMS `json:"THREE_GRAMS,omitempty"`

	// t w o g RAM s
	TWOGRAMS *ShopResponseToleranceMapTWOGRAMS `json:"TWO_GRAMS,omitempty"`
}

// Validate validates this shop response tolerance map
func (m *ShopResponseToleranceMap) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateGRAM(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHALF(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHALFGRAM(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateONEEIGHTTH(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOUNCE(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQUARTER(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTHREEGRAMS(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTWOGRAMS(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseToleranceMap) validateGRAM(formats strfmt.Registry) error {
	if swag.IsZero(m.GRAM) { // not required
		return nil
	}

	if m.GRAM != nil {
		if err := m.GRAM.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "GRAM")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateHALF(formats strfmt.Registry) error {
	if swag.IsZero(m.HALF) { // not required
		return nil
	}

	if m.HALF != nil {
		if err := m.HALF.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "HALF")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateHALFGRAM(formats strfmt.Registry) error {
	if swag.IsZero(m.HALFGRAM) { // not required
		return nil
	}

	if m.HALFGRAM != nil {
		if err := m.HALFGRAM.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "HALF_GRAM")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateONEEIGHTTH(formats strfmt.Registry) error {
	if swag.IsZero(m.ONEEIGHTTH) { // not required
		return nil
	}

	if m.ONEEIGHTTH != nil {
		if err := m.ONEEIGHTTH.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "ONE_EIGHTTH")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateOUNCE(formats strfmt.Registry) error {
	if swag.IsZero(m.OUNCE) { // not required
		return nil
	}

	if m.OUNCE != nil {
		if err := m.OUNCE.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "OUNCE")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateQUARTER(formats strfmt.Registry) error {
	if swag.IsZero(m.QUARTER) { // not required
		return nil
	}

	if m.QUARTER != nil {
		if err := m.QUARTER.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "QUARTER")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateTHREEGRAMS(formats strfmt.Registry) error {
	if swag.IsZero(m.THREEGRAMS) { // not required
		return nil
	}

	if m.THREEGRAMS != nil {
		if err := m.THREEGRAMS.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "THREE_GRAMS")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) validateTWOGRAMS(formats strfmt.Registry) error {
	if swag.IsZero(m.TWOGRAMS) { // not required
		return nil
	}

	if m.TWOGRAMS != nil {
		if err := m.TWOGRAMS.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "TWO_GRAMS")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this shop response tolerance map based on the context it is used
func (m *ShopResponseToleranceMap) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGRAM(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHALF(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHALFGRAM(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateONEEIGHTTH(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateOUNCE(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQUARTER(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTHREEGRAMS(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTWOGRAMS(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ShopResponseToleranceMap) contextValidateGRAM(ctx context.Context, formats strfmt.Registry) error {

	if m.GRAM != nil {
		if err := m.GRAM.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "GRAM")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateHALF(ctx context.Context, formats strfmt.Registry) error {

	if m.HALF != nil {
		if err := m.HALF.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "HALF")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateHALFGRAM(ctx context.Context, formats strfmt.Registry) error {

	if m.HALFGRAM != nil {
		if err := m.HALFGRAM.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "HALF_GRAM")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateONEEIGHTTH(ctx context.Context, formats strfmt.Registry) error {

	if m.ONEEIGHTTH != nil {
		if err := m.ONEEIGHTTH.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "ONE_EIGHTTH")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateOUNCE(ctx context.Context, formats strfmt.Registry) error {

	if m.OUNCE != nil {
		if err := m.OUNCE.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "OUNCE")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateQUARTER(ctx context.Context, formats strfmt.Registry) error {

	if m.QUARTER != nil {
		if err := m.QUARTER.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "QUARTER")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateTHREEGRAMS(ctx context.Context, formats strfmt.Registry) error {

	if m.THREEGRAMS != nil {
		if err := m.THREEGRAMS.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "THREE_GRAMS")
			}
			return err
		}
	}

	return nil
}

func (m *ShopResponseToleranceMap) contextValidateTWOGRAMS(ctx context.Context, formats strfmt.Registry) error {

	if m.TWOGRAMS != nil {
		if err := m.TWOGRAMS.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("toleranceMap" + "." + "TWO_GRAMS")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMap) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMap) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMap
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapGRAM shop response tolerance map g RAM
//
// swagger:model ShopResponseToleranceMapGRAM
type ShopResponseToleranceMapGRAM struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486903
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 1.35
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb09
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486903
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: Gram
	Name string `json:"name,omitempty"`

	// priority
	// Example: 1
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 0.85
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 1
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: GRAM
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 1
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map g RAM
func (m *ShopResponseToleranceMapGRAM) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map g RAM based on context it is used
func (m *ShopResponseToleranceMapGRAM) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapGRAM) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapGRAM) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapGRAM
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapHALF shop response tolerance map h a l f
//
// swagger:model ShopResponseToleranceMapHALF
type ShopResponseToleranceMapHALF struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486905
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 14.5
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb0e
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486905
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: 1/2
	Name string `json:"name,omitempty"`

	// priority
	// Example: 6
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 14
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 14
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: HALF
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 14.17476
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map h a l f
func (m *ShopResponseToleranceMapHALF) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map h a l f based on context it is used
func (m *ShopResponseToleranceMapHALF) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapHALF) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapHALF) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapHALF
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapHALFGRAM shop response tolerance map h a l f g RAM
//
// swagger:model ShopResponseToleranceMapHALFGRAM
type ShopResponseToleranceMapHALFGRAM struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486902
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 0.6
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb08
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486902
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: .5 Gram
	Name string `json:"name,omitempty"`

	// priority
	// Example: 0
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 0.5
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 0.5
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: HALF_GRAM
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 0.5
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map h a l f g RAM
func (m *ShopResponseToleranceMapHALFGRAM) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map h a l f g RAM based on context it is used
func (m *ShopResponseToleranceMapHALFGRAM) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapHALFGRAM) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapHALFGRAM) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapHALFGRAM
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapONEEIGHTTH shop response tolerance map o n e e i g h t t h
//
// swagger:model ShopResponseToleranceMapONEEIGHTTH
type ShopResponseToleranceMapONEEIGHTTH struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486905
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 3.85
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb0c
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486905
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: 1/8th
	Name string `json:"name,omitempty"`

	// priority
	// Example: 4
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 3.45
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 3.5
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: ONE_EIGHTTH
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 3.54369
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map o n e e i g h t t h
func (m *ShopResponseToleranceMapONEEIGHTTH) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map o n e e i g h t t h based on context it is used
func (m *ShopResponseToleranceMapONEEIGHTTH) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapONEEIGHTTH) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapONEEIGHTTH) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapONEEIGHTTH
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapOUNCE shop response tolerance map o u n c e
//
// swagger:model ShopResponseToleranceMapOUNCE
type ShopResponseToleranceMapOUNCE struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486905
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 28.5
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb0f
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486905
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: 1 Oz
	Name string `json:"name,omitempty"`

	// priority
	// Example: 7
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 28
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 28
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: OUNCE
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 28.34952
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map o u n c e
func (m *ShopResponseToleranceMapOUNCE) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map o u n c e based on context it is used
func (m *ShopResponseToleranceMapOUNCE) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapOUNCE) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapOUNCE) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapOUNCE
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapQUARTER shop response tolerance map q u a r t e r
//
// swagger:model ShopResponseToleranceMapQUARTER
type ShopResponseToleranceMapQUARTER struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486905
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 7.5
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb0d
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486905
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: 1/4th
	Name string `json:"name,omitempty"`

	// priority
	// Example: 5
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 7
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 7
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: QUARTER
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 7.087381
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map q u a r t e r
func (m *ShopResponseToleranceMapQUARTER) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map q u a r t e r based on context it is used
func (m *ShopResponseToleranceMapQUARTER) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapQUARTER) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapQUARTER) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapQUARTER
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapTHREEGRAMS shop response tolerance map t h r e e g RAM s
//
// swagger:model ShopResponseToleranceMapTHREEGRAMS
type ShopResponseToleranceMapTHREEGRAMS struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486904
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 3.1
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb0b
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486904
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: 3 Grams
	Name string `json:"name,omitempty"`

	// priority
	// Example: 3
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 3
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 3
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: THREE_GRAMS
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 3
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map t h r e e g RAM s
func (m *ShopResponseToleranceMapTHREEGRAMS) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map t h r e e g RAM s based on context it is used
func (m *ShopResponseToleranceMapTHREEGRAMS) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapTHREEGRAMS) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapTHREEGRAMS) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapTHREEGRAMS
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ShopResponseToleranceMapTWOGRAMS shop response tolerance map t w o g RAM s
//
// swagger:model ShopResponseToleranceMapTWOGRAMS
type ShopResponseToleranceMapTWOGRAMS struct {

	// company Id
	// Example: 5c7e8c7b722ed607e61edb06
	CompanyID string `json:"companyId,omitempty"`

	// created
	// Example: 1551488486903
	Created int64 `json:"created,omitempty"`

	// deleted
	// Example: false
	Deleted bool `json:"deleted,omitempty"`

	// enabled
	// Example: true
	Enabled bool `json:"enabled,omitempty"`

	// end weight
	// Example: 2.1
	EndWeight float64 `json:"endWeight,omitempty"`

	// id
	// Example: 5c7e8c7b722ed607e61edb0a
	ID string `json:"id,omitempty"`

	// modified
	// Example: 1551488486903
	Modified int64 `json:"modified,omitempty"`

	// name
	// Example: 2 Grams
	Name string `json:"name,omitempty"`

	// priority
	// Example: 2
	Priority float64 `json:"priority,omitempty"`

	// start weight
	// Example: 2
	StartWeight float64 `json:"startWeight,omitempty"`

	// unit value
	// Example: 2
	UnitValue float64 `json:"unitValue,omitempty"`

	// updated
	// Example: false
	Updated bool `json:"updated,omitempty"`

	// weight key
	// Example: TWO_GRAMS
	WeightKey string `json:"weightKey,omitempty"`

	// weight value
	// Example: 2
	WeightValue float64 `json:"weightValue,omitempty"`
}

// Validate validates this shop response tolerance map t w o g RAM s
func (m *ShopResponseToleranceMapTWOGRAMS) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this shop response tolerance map t w o g RAM s based on context it is used
func (m *ShopResponseToleranceMapTWOGRAMS) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ShopResponseToleranceMapTWOGRAMS) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ShopResponseToleranceMapTWOGRAMS) UnmarshalBinary(b []byte) error {
	var res ShopResponseToleranceMapTWOGRAMS
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
