// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package place

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/geo/geo_models"
)

// NewPostPlacesParams creates a new PostPlacesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostPlacesParams() *PostPlacesParams {
	return &PostPlacesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostPlacesParamsWithTimeout creates a new PostPlacesParams object
// with the ability to set a timeout on a request.
func NewPostPlacesParamsWithTimeout(timeout time.Duration) *PostPlacesParams {
	return &PostPlacesParams{
		timeout: timeout,
	}
}

// NewPostPlacesParamsWithContext creates a new PostPlacesParams object
// with the ability to set a context for a request.
func NewPostPlacesParamsWithContext(ctx context.Context) *PostPlacesParams {
	return &PostPlacesParams{
		Context: ctx,
	}
}

// NewPostPlacesParamsWithHTTPClient creates a new PostPlacesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostPlacesParamsWithHTTPClient(client *http.Client) *PostPlacesParams {
	return &PostPlacesParams{
		HTTPClient: client,
	}
}

/* PostPlacesParams contains all the parameters to send to the API endpoint
   for the post places operation.

   Typically these are written to a http.Request.
*/
type PostPlacesParams struct {

	/* PlaceRequest.

	   The new Places request package
	*/
	PlaceRequest *geo_models.PlaceRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post places params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPlacesParams) WithDefaults() *PostPlacesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post places params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostPlacesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post places params
func (o *PostPlacesParams) WithTimeout(timeout time.Duration) *PostPlacesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post places params
func (o *PostPlacesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post places params
func (o *PostPlacesParams) WithContext(ctx context.Context) *PostPlacesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post places params
func (o *PostPlacesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post places params
func (o *PostPlacesParams) WithHTTPClient(client *http.Client) *PostPlacesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post places params
func (o *PostPlacesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPlaceRequest adds the placeRequest to the post places params
func (o *PostPlacesParams) WithPlaceRequest(placeRequest *geo_models.PlaceRequest) *PostPlacesParams {
	o.SetPlaceRequest(placeRequest)
	return o
}

// SetPlaceRequest adds the placeRequest to the post places params
func (o *PostPlacesParams) SetPlaceRequest(placeRequest *geo_models.PlaceRequest) {
	o.PlaceRequest = placeRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostPlacesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.PlaceRequest != nil {
		if err := r.SetBodyParam(o.PlaceRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
