// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package taxnexus_code

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new taxnexus code API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for taxnexus code API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetTaxnexusCodeObservable(params *GetTaxnexusCodeObservableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTaxnexusCodeObservableOK, error)

	GetTaxnexusCodes(params *GetTaxnexusCodesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTaxnexusCodesOK, error)

	PostTaxnexusCodes(params *PostTaxnexusCodesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTaxnexusCodesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetTaxnexusCodeObservable gets taxnexuscodes in an observable array

  Returns a taxnexuscode retrieval in a observable array
*/
func (a *Client) GetTaxnexusCodeObservable(params *GetTaxnexusCodeObservableParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTaxnexusCodeObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxnexusCodeObservableParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTaxnexusCodeObservable",
		Method:             "GET",
		PathPattern:        "/taxnexuscodes/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxnexusCodeObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxnexusCodeObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxnexusCodeObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetTaxnexusCodes gets a list of taxnexus codes

  Return a list of TaxnexusCodes
*/
func (a *Client) GetTaxnexusCodes(params *GetTaxnexusCodesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTaxnexusCodesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxnexusCodesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTaxnexusCodes",
		Method:             "GET",
		PathPattern:        "/taxnexuscodes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxnexusCodesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxnexusCodesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxnexusCodes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostTaxnexusCodes stores new taxnexus code records

  Store a batch of new TaxnexusCode records
*/
func (a *Client) PostTaxnexusCodes(params *PostTaxnexusCodesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTaxnexusCodesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxnexusCodesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTaxnexusCodes",
		Method:             "POST",
		PathPattern:        "/taxnexuscodes",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxnexusCodesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxnexusCodesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxnexusCodes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
