// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounting_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ledger/ledger_models"
)

// NewPostAccountingRulesParams creates a new PostAccountingRulesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAccountingRulesParams() *PostAccountingRulesParams {
	return &PostAccountingRulesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAccountingRulesParamsWithTimeout creates a new PostAccountingRulesParams object
// with the ability to set a timeout on a request.
func NewPostAccountingRulesParamsWithTimeout(timeout time.Duration) *PostAccountingRulesParams {
	return &PostAccountingRulesParams{
		timeout: timeout,
	}
}

// NewPostAccountingRulesParamsWithContext creates a new PostAccountingRulesParams object
// with the ability to set a context for a request.
func NewPostAccountingRulesParamsWithContext(ctx context.Context) *PostAccountingRulesParams {
	return &PostAccountingRulesParams{
		Context: ctx,
	}
}

// NewPostAccountingRulesParamsWithHTTPClient creates a new PostAccountingRulesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAccountingRulesParamsWithHTTPClient(client *http.Client) *PostAccountingRulesParams {
	return &PostAccountingRulesParams{
		HTTPClient: client,
	}
}

/* PostAccountingRulesParams contains all the parameters to send to the API endpoint
   for the post accounting rules operation.

   Typically these are written to a http.Request.
*/
type PostAccountingRulesParams struct {

	/* AccountingRuleRequest.

	   An array of Accounting Rule records
	*/
	AccountingRuleRequest *ledger_models.AccountingRuleRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post accounting rules params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAccountingRulesParams) WithDefaults() *PostAccountingRulesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post accounting rules params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAccountingRulesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post accounting rules params
func (o *PostAccountingRulesParams) WithTimeout(timeout time.Duration) *PostAccountingRulesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post accounting rules params
func (o *PostAccountingRulesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post accounting rules params
func (o *PostAccountingRulesParams) WithContext(ctx context.Context) *PostAccountingRulesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post accounting rules params
func (o *PostAccountingRulesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post accounting rules params
func (o *PostAccountingRulesParams) WithHTTPClient(client *http.Client) *PostAccountingRulesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post accounting rules params
func (o *PostAccountingRulesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountingRuleRequest adds the accountingRuleRequest to the post accounting rules params
func (o *PostAccountingRulesParams) WithAccountingRuleRequest(accountingRuleRequest *ledger_models.AccountingRuleRequest) *PostAccountingRulesParams {
	o.SetAccountingRuleRequest(accountingRuleRequest)
	return o
}

// SetAccountingRuleRequest adds the accountingRuleRequest to the post accounting rules params
func (o *PostAccountingRulesParams) SetAccountingRuleRequest(accountingRuleRequest *ledger_models.AccountingRuleRequest) {
	o.AccountingRuleRequest = accountingRuleRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostAccountingRulesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.AccountingRuleRequest != nil {
		if err := r.SetBodyParam(o.AccountingRuleRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
