// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package journal_item

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetJournalItemsParams creates a new GetJournalItemsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetJournalItemsParams() *GetJournalItemsParams {
	return &GetJournalItemsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetJournalItemsParamsWithTimeout creates a new GetJournalItemsParams object
// with the ability to set a timeout on a request.
func NewGetJournalItemsParamsWithTimeout(timeout time.Duration) *GetJournalItemsParams {
	return &GetJournalItemsParams{
		timeout: timeout,
	}
}

// NewGetJournalItemsParamsWithContext creates a new GetJournalItemsParams object
// with the ability to set a context for a request.
func NewGetJournalItemsParamsWithContext(ctx context.Context) *GetJournalItemsParams {
	return &GetJournalItemsParams{
		Context: ctx,
	}
}

// NewGetJournalItemsParamsWithHTTPClient creates a new GetJournalItemsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetJournalItemsParamsWithHTTPClient(client *http.Client) *GetJournalItemsParams {
	return &GetJournalItemsParams{
		HTTPClient: client,
	}
}

/* GetJournalItemsParams contains all the parameters to send to the API endpoint
   for the get journal items operation.

   Typically these are written to a http.Request.
*/
type GetJournalItemsParams struct {

	/* AccountID.

	   Taxnexus Record Id of an Account
	*/
	AccountID string

	/* Month.

	   The Month Number (1,2, ..., 12) of the report

	   Format: int64
	*/
	Month *int64

	/* Quarter.

	   The Quarter Number (1,2,3,4) of the report

	   Format: int64
	*/
	Quarter *int64

	/* Year.

	   The year of the report

	   Format: int64
	*/
	Year *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get journal items params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetJournalItemsParams) WithDefaults() *GetJournalItemsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get journal items params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetJournalItemsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get journal items params
func (o *GetJournalItemsParams) WithTimeout(timeout time.Duration) *GetJournalItemsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get journal items params
func (o *GetJournalItemsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get journal items params
func (o *GetJournalItemsParams) WithContext(ctx context.Context) *GetJournalItemsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get journal items params
func (o *GetJournalItemsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get journal items params
func (o *GetJournalItemsParams) WithHTTPClient(client *http.Client) *GetJournalItemsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get journal items params
func (o *GetJournalItemsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get journal items params
func (o *GetJournalItemsParams) WithAccountID(accountID string) *GetJournalItemsParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get journal items params
func (o *GetJournalItemsParams) SetAccountID(accountID string) {
	o.AccountID = accountID
}

// WithMonth adds the month to the get journal items params
func (o *GetJournalItemsParams) WithMonth(month *int64) *GetJournalItemsParams {
	o.SetMonth(month)
	return o
}

// SetMonth adds the month to the get journal items params
func (o *GetJournalItemsParams) SetMonth(month *int64) {
	o.Month = month
}

// WithQuarter adds the quarter to the get journal items params
func (o *GetJournalItemsParams) WithQuarter(quarter *int64) *GetJournalItemsParams {
	o.SetQuarter(quarter)
	return o
}

// SetQuarter adds the quarter to the get journal items params
func (o *GetJournalItemsParams) SetQuarter(quarter *int64) {
	o.Quarter = quarter
}

// WithYear adds the year to the get journal items params
func (o *GetJournalItemsParams) WithYear(year *int64) *GetJournalItemsParams {
	o.SetYear(year)
	return o
}

// SetYear adds the year to the get journal items params
func (o *GetJournalItemsParams) SetYear(year *int64) {
	o.Year = year
}

// WriteToRequest writes these params to a swagger request
func (o *GetJournalItemsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param accountId
	qrAccountID := o.AccountID
	qAccountID := qrAccountID
	if qAccountID != "" {

		if err := r.SetQueryParam("accountId", qAccountID); err != nil {
			return err
		}
	}

	if o.Month != nil {

		// query param month
		var qrMonth int64

		if o.Month != nil {
			qrMonth = *o.Month
		}
		qMonth := swag.FormatInt64(qrMonth)
		if qMonth != "" {

			if err := r.SetQueryParam("month", qMonth); err != nil {
				return err
			}
		}
	}

	if o.Quarter != nil {

		// query param quarter
		var qrQuarter int64

		if o.Quarter != nil {
			qrQuarter = *o.Quarter
		}
		qQuarter := swag.FormatInt64(qrQuarter)
		if qQuarter != "" {

			if err := r.SetQueryParam("quarter", qQuarter); err != nil {
				return err
			}
		}
	}

	if o.Year != nil {

		// query param year
		var qrYear int64

		if o.Year != nil {
			qrYear = *o.Year
		}
		qYear := swag.FormatInt64(qrYear)
		if qYear != "" {

			if err := r.SetQueryParam("year", qYear); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
