// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package rating_engine

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteRatingEngineParams creates a new DeleteRatingEngineParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteRatingEngineParams() *DeleteRatingEngineParams {
	return &DeleteRatingEngineParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteRatingEngineParamsWithTimeout creates a new DeleteRatingEngineParams object
// with the ability to set a timeout on a request.
func NewDeleteRatingEngineParamsWithTimeout(timeout time.Duration) *DeleteRatingEngineParams {
	return &DeleteRatingEngineParams{
		timeout: timeout,
	}
}

// NewDeleteRatingEngineParamsWithContext creates a new DeleteRatingEngineParams object
// with the ability to set a context for a request.
func NewDeleteRatingEngineParamsWithContext(ctx context.Context) *DeleteRatingEngineParams {
	return &DeleteRatingEngineParams{
		Context: ctx,
	}
}

// NewDeleteRatingEngineParamsWithHTTPClient creates a new DeleteRatingEngineParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteRatingEngineParamsWithHTTPClient(client *http.Client) *DeleteRatingEngineParams {
	return &DeleteRatingEngineParams{
		HTTPClient: client,
	}
}

/* DeleteRatingEngineParams contains all the parameters to send to the API endpoint
   for the delete rating engine operation.

   Typically these are written to a http.Request.
*/
type DeleteRatingEngineParams struct {

	/* ID.

	   Taxnexus Id of the Record to be retrieved
	*/
	ID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete rating engine params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRatingEngineParams) WithDefaults() *DeleteRatingEngineParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete rating engine params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteRatingEngineParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete rating engine params
func (o *DeleteRatingEngineParams) WithTimeout(timeout time.Duration) *DeleteRatingEngineParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete rating engine params
func (o *DeleteRatingEngineParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete rating engine params
func (o *DeleteRatingEngineParams) WithContext(ctx context.Context) *DeleteRatingEngineParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete rating engine params
func (o *DeleteRatingEngineParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete rating engine params
func (o *DeleteRatingEngineParams) WithHTTPClient(client *http.Client) *DeleteRatingEngineParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete rating engine params
func (o *DeleteRatingEngineParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the delete rating engine params
func (o *DeleteRatingEngineParams) WithID(id *string) *DeleteRatingEngineParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the delete rating engine params
func (o *DeleteRatingEngineParams) SetID(id *string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteRatingEngineParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
