// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package account

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/render/render_models"
)

// GetRenderAccountIQReader is a Reader for the GetRenderAccountIQ structure.
type GetRenderAccountIQReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRenderAccountIQReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRenderAccountIQOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetRenderAccountIQUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetRenderAccountIQForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetRenderAccountIQNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetRenderAccountIQUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRenderAccountIQInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetRenderAccountIQOK creates a GetRenderAccountIQOK with default headers values
func NewGetRenderAccountIQOK() *GetRenderAccountIQOK {
	return &GetRenderAccountIQOK{}
}

/* GetRenderAccountIQOK describes a response with status code 200, with default header values.

Rendered documents response
*/
type GetRenderAccountIQOK struct {
	AccessControlAllowOrigin string

	Payload *render_models.DocumentResponse
}

func (o *GetRenderAccountIQOK) Error() string {
	return fmt.Sprintf("[GET /accounts/iq][%d] getRenderAccountIQOK  %+v", 200, o.Payload)
}
func (o *GetRenderAccountIQOK) GetPayload() *render_models.DocumentResponse {
	return o.Payload
}

func (o *GetRenderAccountIQOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.DocumentResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountIQUnauthorized creates a GetRenderAccountIQUnauthorized with default headers values
func NewGetRenderAccountIQUnauthorized() *GetRenderAccountIQUnauthorized {
	return &GetRenderAccountIQUnauthorized{}
}

/* GetRenderAccountIQUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetRenderAccountIQUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountIQUnauthorized) Error() string {
	return fmt.Sprintf("[GET /accounts/iq][%d] getRenderAccountIQUnauthorized  %+v", 401, o.Payload)
}
func (o *GetRenderAccountIQUnauthorized) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountIQUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountIQForbidden creates a GetRenderAccountIQForbidden with default headers values
func NewGetRenderAccountIQForbidden() *GetRenderAccountIQForbidden {
	return &GetRenderAccountIQForbidden{}
}

/* GetRenderAccountIQForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetRenderAccountIQForbidden struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountIQForbidden) Error() string {
	return fmt.Sprintf("[GET /accounts/iq][%d] getRenderAccountIQForbidden  %+v", 403, o.Payload)
}
func (o *GetRenderAccountIQForbidden) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountIQForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountIQNotFound creates a GetRenderAccountIQNotFound with default headers values
func NewGetRenderAccountIQNotFound() *GetRenderAccountIQNotFound {
	return &GetRenderAccountIQNotFound{}
}

/* GetRenderAccountIQNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetRenderAccountIQNotFound struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountIQNotFound) Error() string {
	return fmt.Sprintf("[GET /accounts/iq][%d] getRenderAccountIQNotFound  %+v", 404, o.Payload)
}
func (o *GetRenderAccountIQNotFound) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountIQNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountIQUnprocessableEntity creates a GetRenderAccountIQUnprocessableEntity with default headers values
func NewGetRenderAccountIQUnprocessableEntity() *GetRenderAccountIQUnprocessableEntity {
	return &GetRenderAccountIQUnprocessableEntity{}
}

/* GetRenderAccountIQUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetRenderAccountIQUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountIQUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /accounts/iq][%d] getRenderAccountIQUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetRenderAccountIQUnprocessableEntity) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountIQUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountIQInternalServerError creates a GetRenderAccountIQInternalServerError with default headers values
func NewGetRenderAccountIQInternalServerError() *GetRenderAccountIQInternalServerError {
	return &GetRenderAccountIQInternalServerError{}
}

/* GetRenderAccountIQInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetRenderAccountIQInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountIQInternalServerError) Error() string {
	return fmt.Sprintf("[GET /accounts/iq][%d] getRenderAccountIQInternalServerError  %+v", 500, o.Payload)
}
func (o *GetRenderAccountIQInternalServerError) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountIQInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
