// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package account

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/render/render_models"
)

// GetRenderAccountPandLReader is a Reader for the GetRenderAccountPandL structure.
type GetRenderAccountPandLReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetRenderAccountPandLReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetRenderAccountPandLOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetRenderAccountPandLUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetRenderAccountPandLForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetRenderAccountPandLNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetRenderAccountPandLUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetRenderAccountPandLInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetRenderAccountPandLOK creates a GetRenderAccountPandLOK with default headers values
func NewGetRenderAccountPandLOK() *GetRenderAccountPandLOK {
	return &GetRenderAccountPandLOK{}
}

/* GetRenderAccountPandLOK describes a response with status code 200, with default header values.

Rendered documents response
*/
type GetRenderAccountPandLOK struct {
	AccessControlAllowOrigin string

	Payload *render_models.DocumentResponse
}

func (o *GetRenderAccountPandLOK) Error() string {
	return fmt.Sprintf("[GET /accounts/profitloss][%d] getRenderAccountPandLOK  %+v", 200, o.Payload)
}
func (o *GetRenderAccountPandLOK) GetPayload() *render_models.DocumentResponse {
	return o.Payload
}

func (o *GetRenderAccountPandLOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.DocumentResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountPandLUnauthorized creates a GetRenderAccountPandLUnauthorized with default headers values
func NewGetRenderAccountPandLUnauthorized() *GetRenderAccountPandLUnauthorized {
	return &GetRenderAccountPandLUnauthorized{}
}

/* GetRenderAccountPandLUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetRenderAccountPandLUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountPandLUnauthorized) Error() string {
	return fmt.Sprintf("[GET /accounts/profitloss][%d] getRenderAccountPandLUnauthorized  %+v", 401, o.Payload)
}
func (o *GetRenderAccountPandLUnauthorized) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountPandLUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountPandLForbidden creates a GetRenderAccountPandLForbidden with default headers values
func NewGetRenderAccountPandLForbidden() *GetRenderAccountPandLForbidden {
	return &GetRenderAccountPandLForbidden{}
}

/* GetRenderAccountPandLForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetRenderAccountPandLForbidden struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountPandLForbidden) Error() string {
	return fmt.Sprintf("[GET /accounts/profitloss][%d] getRenderAccountPandLForbidden  %+v", 403, o.Payload)
}
func (o *GetRenderAccountPandLForbidden) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountPandLForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountPandLNotFound creates a GetRenderAccountPandLNotFound with default headers values
func NewGetRenderAccountPandLNotFound() *GetRenderAccountPandLNotFound {
	return &GetRenderAccountPandLNotFound{}
}

/* GetRenderAccountPandLNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetRenderAccountPandLNotFound struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountPandLNotFound) Error() string {
	return fmt.Sprintf("[GET /accounts/profitloss][%d] getRenderAccountPandLNotFound  %+v", 404, o.Payload)
}
func (o *GetRenderAccountPandLNotFound) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountPandLNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountPandLUnprocessableEntity creates a GetRenderAccountPandLUnprocessableEntity with default headers values
func NewGetRenderAccountPandLUnprocessableEntity() *GetRenderAccountPandLUnprocessableEntity {
	return &GetRenderAccountPandLUnprocessableEntity{}
}

/* GetRenderAccountPandLUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetRenderAccountPandLUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountPandLUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /accounts/profitloss][%d] getRenderAccountPandLUnprocessableEntity  %+v", 422, o.Payload)
}
func (o *GetRenderAccountPandLUnprocessableEntity) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountPandLUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetRenderAccountPandLInternalServerError creates a GetRenderAccountPandLInternalServerError with default headers values
func NewGetRenderAccountPandLInternalServerError() *GetRenderAccountPandLInternalServerError {
	return &GetRenderAccountPandLInternalServerError{}
}

/* GetRenderAccountPandLInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetRenderAccountPandLInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *render_models.Error
}

func (o *GetRenderAccountPandLInternalServerError) Error() string {
	return fmt.Sprintf("[GET /accounts/profitloss][%d] getRenderAccountPandLInternalServerError  %+v", 500, o.Payload)
}
func (o *GetRenderAccountPandLInternalServerError) GetPayload() *render_models.Error {
	return o.Payload
}

func (o *GetRenderAccountPandLInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(render_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
