// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new cors API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for cors API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	AccountIQOptions(params *AccountIQOptionsParams, opts ...ClientOption) (*AccountIQOptionsOK, error)

	AccountPandLOptions(params *AccountPandLOptionsParams, opts ...ClientOption) (*AccountPandLOptionsOK, error)

	TaxOptions(params *TaxOptionsParams, opts ...ClientOption) (*TaxOptionsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  AccountIQOptions CORS support
*/
func (a *Client) AccountIQOptions(params *AccountIQOptionsParams, opts ...ClientOption) (*AccountIQOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewAccountIQOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "accountIQOptions",
		Method:             "OPTIONS",
		PathPattern:        "/accounts/iq",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &AccountIQOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*AccountIQOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for accountIQOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  AccountPandLOptions CORS support
*/
func (a *Client) AccountPandLOptions(params *AccountPandLOptionsParams, opts ...ClientOption) (*AccountPandLOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewAccountPandLOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "accountPandLOptions",
		Method:             "OPTIONS",
		PathPattern:        "/accounts/profitloss",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &AccountPandLOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*AccountPandLOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for accountPandLOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  TaxOptions CORS support
*/
func (a *Client) TaxOptions(params *TaxOptionsParams, opts ...ClientOption) (*TaxOptionsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewTaxOptionsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "taxOptions",
		Method:             "OPTIONS",
		PathPattern:        "/accounts/tax",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &TaxOptionsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*TaxOptionsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for taxOptions: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
