// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package orders

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// NewPostOrdersParams creates a new PostOrdersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostOrdersParams() *PostOrdersParams {
	return &PostOrdersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostOrdersParamsWithTimeout creates a new PostOrdersParams object
// with the ability to set a timeout on a request.
func NewPostOrdersParamsWithTimeout(timeout time.Duration) *PostOrdersParams {
	return &PostOrdersParams{
		timeout: timeout,
	}
}

// NewPostOrdersParamsWithContext creates a new PostOrdersParams object
// with the ability to set a context for a request.
func NewPostOrdersParamsWithContext(ctx context.Context) *PostOrdersParams {
	return &PostOrdersParams{
		Context: ctx,
	}
}

// NewPostOrdersParamsWithHTTPClient creates a new PostOrdersParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostOrdersParamsWithHTTPClient(client *http.Client) *PostOrdersParams {
	return &PostOrdersParams{
		HTTPClient: client,
	}
}

/* PostOrdersParams contains all the parameters to send to the API endpoint
   for the post orders operation.

   Typically these are written to a http.Request.
*/
type PostOrdersParams struct {

	// Order.
	Order *sf_gate_models.OrderBasicRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post orders params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostOrdersParams) WithDefaults() *PostOrdersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post orders params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostOrdersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post orders params
func (o *PostOrdersParams) WithTimeout(timeout time.Duration) *PostOrdersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post orders params
func (o *PostOrdersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post orders params
func (o *PostOrdersParams) WithContext(ctx context.Context) *PostOrdersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post orders params
func (o *PostOrdersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post orders params
func (o *PostOrdersParams) WithHTTPClient(client *http.Client) *PostOrdersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post orders params
func (o *PostOrdersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrder adds the order to the post orders params
func (o *PostOrdersParams) WithOrder(order *sf_gate_models.OrderBasicRequest) *PostOrdersParams {
	o.SetOrder(order)
	return o
}

// SetOrder adds the order to the post orders params
func (o *PostOrdersParams) SetOrder(order *sf_gate_models.OrderBasicRequest) {
	o.Order = order
}

// WriteToRequest writes these params to a swagger request
func (o *PostOrdersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Order != nil {
		if err := r.SetBodyParam(o.Order); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
