// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2021 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package taxnexus_codes

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetTaxnexusCodesParams creates a new GetTaxnexusCodesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetTaxnexusCodesParams() *GetTaxnexusCodesParams {
	return &GetTaxnexusCodesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetTaxnexusCodesParamsWithTimeout creates a new GetTaxnexusCodesParams object
// with the ability to set a timeout on a request.
func NewGetTaxnexusCodesParamsWithTimeout(timeout time.Duration) *GetTaxnexusCodesParams {
	return &GetTaxnexusCodesParams{
		timeout: timeout,
	}
}

// NewGetTaxnexusCodesParamsWithContext creates a new GetTaxnexusCodesParams object
// with the ability to set a context for a request.
func NewGetTaxnexusCodesParamsWithContext(ctx context.Context) *GetTaxnexusCodesParams {
	return &GetTaxnexusCodesParams{
		Context: ctx,
	}
}

// NewGetTaxnexusCodesParamsWithHTTPClient creates a new GetTaxnexusCodesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetTaxnexusCodesParamsWithHTTPClient(client *http.Client) *GetTaxnexusCodesParams {
	return &GetTaxnexusCodesParams{
		HTTPClient: client,
	}
}

/* GetTaxnexusCodesParams contains all the parameters to send to the API endpoint
   for the get taxnexus codes operation.

   Typically these are written to a http.Request.
*/
type GetTaxnexusCodesParams struct {

	/* Active.

	   Retrieve only active records?
	*/
	Active *bool

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip? (default 0)

	   Format: int64
	*/
	Offset *int64

	/* TaxnexuscodeID.

	   Taxnexus Id of the Taxnexus Code to be retrieved
	*/
	TaxnexuscodeID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get taxnexus codes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTaxnexusCodesParams) WithDefaults() *GetTaxnexusCodesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get taxnexus codes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTaxnexusCodesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithTimeout(timeout time.Duration) *GetTaxnexusCodesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithContext(ctx context.Context) *GetTaxnexusCodesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithHTTPClient(client *http.Client) *GetTaxnexusCodesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithActive(active *bool) *GetTaxnexusCodesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetActive(active *bool) {
	o.Active = active
}

// WithLimit adds the limit to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithLimit(limit *int64) *GetTaxnexusCodesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithOffset(offset *int64) *GetTaxnexusCodesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithTaxnexuscodeID adds the taxnexuscodeID to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) WithTaxnexuscodeID(taxnexuscodeID *string) *GetTaxnexusCodesParams {
	o.SetTaxnexuscodeID(taxnexuscodeID)
	return o
}

// SetTaxnexuscodeID adds the taxnexuscodeId to the get taxnexus codes params
func (o *GetTaxnexusCodesParams) SetTaxnexuscodeID(taxnexuscodeID *string) {
	o.TaxnexuscodeID = taxnexuscodeID
}

// WriteToRequest writes these params to a swagger request
func (o *GetTaxnexusCodesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.TaxnexuscodeID != nil {

		// query param taxnexuscodeId
		var qrTaxnexuscodeID string

		if o.TaxnexuscodeID != nil {
			qrTaxnexuscodeID = *o.TaxnexuscodeID
		}
		qTaxnexuscodeID := qrTaxnexuscodeID
		if qTaxnexuscodeID != "" {

			if err := r.SetQueryParam("taxnexuscodeId", qTaxnexuscodeID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
